package polyhedra;

public abstract class Prism {
    private double height;

    public Prism(double height) {
	this.height = height;
    }

    public abstract double area();

    public final double volume() {
	return area() * height;
    }

    public abstract String toString();

    @Override
    public boolean equals(Object obj) {
	if (obj == null) 
	    return false;
	if (!getClass().equals(obj.getClass()))
	    return false;
	Prism p = (Prism)obj;
	return volume() == p.volume();
    }
}
